// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * MISSING DOCUMENTATION!!!
 * </pre>
 *
 * Protobuf type {@code essmodule.ESSCapabilityConfiguration}
 */
public final class ESSCapabilityConfiguration extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.ESSCapabilityConfiguration)
    ESSCapabilityConfigurationOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ESSCapabilityConfiguration.newBuilder() to construct.
  private ESSCapabilityConfiguration(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ESSCapabilityConfiguration() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ESSCapabilityConfiguration();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityConfiguration_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityConfiguration_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.ESSCapabilityConfiguration.class, openfmb.essmodule.ESSCapabilityConfiguration.Builder.class);
  }

  public static final int SOURCECAPABILITYCONFIGURATION_FIELD_NUMBER = 1;
  private openfmb.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the sourceCapabilityConfiguration field is set.
   */
  @java.lang.Override
  public boolean hasSourceCapabilityConfiguration() {
    return sourceCapabilityConfiguration_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
   * @return The sourceCapabilityConfiguration.
   */
  @java.lang.Override
  public openfmb.commonmodule.SourceCapabilityConfiguration getSourceCapabilityConfiguration() {
    return sourceCapabilityConfiguration_ == null ? openfmb.commonmodule.SourceCapabilityConfiguration.getDefaultInstance() : sourceCapabilityConfiguration_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.SourceCapabilityConfigurationOrBuilder getSourceCapabilityConfigurationOrBuilder() {
    return sourceCapabilityConfiguration_ == null ? openfmb.commonmodule.SourceCapabilityConfiguration.getDefaultInstance() : sourceCapabilityConfiguration_;
  }

  public static final int VACHARTEMAX_FIELD_NUMBER = 2;
  private openfmb.commonmodule.ASG vAChaRteMax_;
  /**
   * <pre>
   * Apparent Power Charge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
   * @return Whether the vAChaRteMax field is set.
   */
  @java.lang.Override
  public boolean hasVAChaRteMax() {
    return vAChaRteMax_ != null;
  }
  /**
   * <pre>
   * Apparent Power Charge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
   * @return The vAChaRteMax.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getVAChaRteMax() {
    return vAChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMax_;
  }
  /**
   * <pre>
   * Apparent Power Charge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getVAChaRteMaxOrBuilder() {
    return vAChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMax_;
  }

  public static final int VADISCHARTEMAX_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ASG vADisChaRteMax_;
  /**
   * <pre>
   * Apparent Power Discharge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
   * @return Whether the vADisChaRteMax field is set.
   */
  @java.lang.Override
  public boolean hasVADisChaRteMax() {
    return vADisChaRteMax_ != null;
  }
  /**
   * <pre>
   * Apparent Power Discharge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
   * @return The vADisChaRteMax.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getVADisChaRteMax() {
    return vADisChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMax_;
  }
  /**
   * <pre>
   * Apparent Power Discharge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getVADisChaRteMaxOrBuilder() {
    return vADisChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMax_;
  }

  public static final int WCHARTEMAX_FIELD_NUMBER = 4;
  private openfmb.commonmodule.ASG wChaRteMax_;
  /**
   * <pre>
   * Active Power Charge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG WChaRteMax = 4;</code>
   * @return Whether the wChaRteMax field is set.
   */
  @java.lang.Override
  public boolean hasWChaRteMax() {
    return wChaRteMax_ != null;
  }
  /**
   * <pre>
   * Active Power Charge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG WChaRteMax = 4;</code>
   * @return The wChaRteMax.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getWChaRteMax() {
    return wChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMax_;
  }
  /**
   * <pre>
   * Active Power Charge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG WChaRteMax = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getWChaRteMaxOrBuilder() {
    return wChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMax_;
  }

  public static final int WDISCHARTEMAX_FIELD_NUMBER = 5;
  private openfmb.commonmodule.ASG wDisChaRteMax_;
  /**
   * <pre>
   * Active Power Discharge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
   * @return Whether the wDisChaRteMax field is set.
   */
  @java.lang.Override
  public boolean hasWDisChaRteMax() {
    return wDisChaRteMax_ != null;
  }
  /**
   * <pre>
   * Active Power Discharge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
   * @return The wDisChaRteMax.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getWDisChaRteMax() {
    return wDisChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMax_;
  }
  /**
   * <pre>
   * Active Power Discharge Maximum
   * </pre>
   *
   * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getWDisChaRteMaxOrBuilder() {
    return wDisChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMax_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (sourceCapabilityConfiguration_ != null) {
      output.writeMessage(1, getSourceCapabilityConfiguration());
    }
    if (vAChaRteMax_ != null) {
      output.writeMessage(2, getVAChaRteMax());
    }
    if (vADisChaRteMax_ != null) {
      output.writeMessage(3, getVADisChaRteMax());
    }
    if (wChaRteMax_ != null) {
      output.writeMessage(4, getWChaRteMax());
    }
    if (wDisChaRteMax_ != null) {
      output.writeMessage(5, getWDisChaRteMax());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (sourceCapabilityConfiguration_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getSourceCapabilityConfiguration());
    }
    if (vAChaRteMax_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getVAChaRteMax());
    }
    if (vADisChaRteMax_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getVADisChaRteMax());
    }
    if (wChaRteMax_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getWChaRteMax());
    }
    if (wDisChaRteMax_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getWDisChaRteMax());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.ESSCapabilityConfiguration)) {
      return super.equals(obj);
    }
    openfmb.essmodule.ESSCapabilityConfiguration other = (openfmb.essmodule.ESSCapabilityConfiguration) obj;

    if (hasSourceCapabilityConfiguration() != other.hasSourceCapabilityConfiguration()) return false;
    if (hasSourceCapabilityConfiguration()) {
      if (!getSourceCapabilityConfiguration()
          .equals(other.getSourceCapabilityConfiguration())) return false;
    }
    if (hasVAChaRteMax() != other.hasVAChaRteMax()) return false;
    if (hasVAChaRteMax()) {
      if (!getVAChaRteMax()
          .equals(other.getVAChaRteMax())) return false;
    }
    if (hasVADisChaRteMax() != other.hasVADisChaRteMax()) return false;
    if (hasVADisChaRteMax()) {
      if (!getVADisChaRteMax()
          .equals(other.getVADisChaRteMax())) return false;
    }
    if (hasWChaRteMax() != other.hasWChaRteMax()) return false;
    if (hasWChaRteMax()) {
      if (!getWChaRteMax()
          .equals(other.getWChaRteMax())) return false;
    }
    if (hasWDisChaRteMax() != other.hasWDisChaRteMax()) return false;
    if (hasWDisChaRteMax()) {
      if (!getWDisChaRteMax()
          .equals(other.getWDisChaRteMax())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasSourceCapabilityConfiguration()) {
      hash = (37 * hash) + SOURCECAPABILITYCONFIGURATION_FIELD_NUMBER;
      hash = (53 * hash) + getSourceCapabilityConfiguration().hashCode();
    }
    if (hasVAChaRteMax()) {
      hash = (37 * hash) + VACHARTEMAX_FIELD_NUMBER;
      hash = (53 * hash) + getVAChaRteMax().hashCode();
    }
    if (hasVADisChaRteMax()) {
      hash = (37 * hash) + VADISCHARTEMAX_FIELD_NUMBER;
      hash = (53 * hash) + getVADisChaRteMax().hashCode();
    }
    if (hasWChaRteMax()) {
      hash = (37 * hash) + WCHARTEMAX_FIELD_NUMBER;
      hash = (53 * hash) + getWChaRteMax().hashCode();
    }
    if (hasWDisChaRteMax()) {
      hash = (37 * hash) + WDISCHARTEMAX_FIELD_NUMBER;
      hash = (53 * hash) + getWDisChaRteMax().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapabilityConfiguration parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.ESSCapabilityConfiguration prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * Protobuf type {@code essmodule.ESSCapabilityConfiguration}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.ESSCapabilityConfiguration)
      openfmb.essmodule.ESSCapabilityConfigurationOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityConfiguration_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityConfiguration_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.ESSCapabilityConfiguration.class, openfmb.essmodule.ESSCapabilityConfiguration.Builder.class);
    }

    // Construct using openfmb.essmodule.ESSCapabilityConfiguration.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      sourceCapabilityConfiguration_ = null;
      if (sourceCapabilityConfigurationBuilder_ != null) {
        sourceCapabilityConfigurationBuilder_.dispose();
        sourceCapabilityConfigurationBuilder_ = null;
      }
      vAChaRteMax_ = null;
      if (vAChaRteMaxBuilder_ != null) {
        vAChaRteMaxBuilder_.dispose();
        vAChaRteMaxBuilder_ = null;
      }
      vADisChaRteMax_ = null;
      if (vADisChaRteMaxBuilder_ != null) {
        vADisChaRteMaxBuilder_.dispose();
        vADisChaRteMaxBuilder_ = null;
      }
      wChaRteMax_ = null;
      if (wChaRteMaxBuilder_ != null) {
        wChaRteMaxBuilder_.dispose();
        wChaRteMaxBuilder_ = null;
      }
      wDisChaRteMax_ = null;
      if (wDisChaRteMaxBuilder_ != null) {
        wDisChaRteMaxBuilder_.dispose();
        wDisChaRteMaxBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityConfiguration_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapabilityConfiguration getDefaultInstanceForType() {
      return openfmb.essmodule.ESSCapabilityConfiguration.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapabilityConfiguration build() {
      openfmb.essmodule.ESSCapabilityConfiguration result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapabilityConfiguration buildPartial() {
      openfmb.essmodule.ESSCapabilityConfiguration result = new openfmb.essmodule.ESSCapabilityConfiguration(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.ESSCapabilityConfiguration result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.sourceCapabilityConfiguration_ = sourceCapabilityConfigurationBuilder_ == null
            ? sourceCapabilityConfiguration_
            : sourceCapabilityConfigurationBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.vAChaRteMax_ = vAChaRteMaxBuilder_ == null
            ? vAChaRteMax_
            : vAChaRteMaxBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.vADisChaRteMax_ = vADisChaRteMaxBuilder_ == null
            ? vADisChaRteMax_
            : vADisChaRteMaxBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.wChaRteMax_ = wChaRteMaxBuilder_ == null
            ? wChaRteMax_
            : wChaRteMaxBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.wDisChaRteMax_ = wDisChaRteMaxBuilder_ == null
            ? wDisChaRteMax_
            : wDisChaRteMaxBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.ESSCapabilityConfiguration) {
        return mergeFrom((openfmb.essmodule.ESSCapabilityConfiguration)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.ESSCapabilityConfiguration other) {
      if (other == openfmb.essmodule.ESSCapabilityConfiguration.getDefaultInstance()) return this;
      if (other.hasSourceCapabilityConfiguration()) {
        mergeSourceCapabilityConfiguration(other.getSourceCapabilityConfiguration());
      }
      if (other.hasVAChaRteMax()) {
        mergeVAChaRteMax(other.getVAChaRteMax());
      }
      if (other.hasVADisChaRteMax()) {
        mergeVADisChaRteMax(other.getVADisChaRteMax());
      }
      if (other.hasWChaRteMax()) {
        mergeWChaRteMax(other.getWChaRteMax());
      }
      if (other.hasWDisChaRteMax()) {
        mergeWDisChaRteMax(other.getWDisChaRteMax());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getSourceCapabilityConfigurationFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getVAChaRteMaxFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getVADisChaRteMaxFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getWChaRteMaxFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getWDisChaRteMaxFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.SourceCapabilityConfiguration, openfmb.commonmodule.SourceCapabilityConfiguration.Builder, openfmb.commonmodule.SourceCapabilityConfigurationOrBuilder> sourceCapabilityConfigurationBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the sourceCapabilityConfiguration field is set.
     */
    public boolean hasSourceCapabilityConfiguration() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     * @return The sourceCapabilityConfiguration.
     */
    public openfmb.commonmodule.SourceCapabilityConfiguration getSourceCapabilityConfiguration() {
      if (sourceCapabilityConfigurationBuilder_ == null) {
        return sourceCapabilityConfiguration_ == null ? openfmb.commonmodule.SourceCapabilityConfiguration.getDefaultInstance() : sourceCapabilityConfiguration_;
      } else {
        return sourceCapabilityConfigurationBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setSourceCapabilityConfiguration(openfmb.commonmodule.SourceCapabilityConfiguration value) {
      if (sourceCapabilityConfigurationBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        sourceCapabilityConfiguration_ = value;
      } else {
        sourceCapabilityConfigurationBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setSourceCapabilityConfiguration(
        openfmb.commonmodule.SourceCapabilityConfiguration.Builder builderForValue) {
      if (sourceCapabilityConfigurationBuilder_ == null) {
        sourceCapabilityConfiguration_ = builderForValue.build();
      } else {
        sourceCapabilityConfigurationBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeSourceCapabilityConfiguration(openfmb.commonmodule.SourceCapabilityConfiguration value) {
      if (sourceCapabilityConfigurationBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          sourceCapabilityConfiguration_ != null &&
          sourceCapabilityConfiguration_ != openfmb.commonmodule.SourceCapabilityConfiguration.getDefaultInstance()) {
          getSourceCapabilityConfigurationBuilder().mergeFrom(value);
        } else {
          sourceCapabilityConfiguration_ = value;
        }
      } else {
        sourceCapabilityConfigurationBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearSourceCapabilityConfiguration() {
      bitField0_ = (bitField0_ & ~0x00000001);
      sourceCapabilityConfiguration_ = null;
      if (sourceCapabilityConfigurationBuilder_ != null) {
        sourceCapabilityConfigurationBuilder_.dispose();
        sourceCapabilityConfigurationBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.SourceCapabilityConfiguration.Builder getSourceCapabilityConfigurationBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getSourceCapabilityConfigurationFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.SourceCapabilityConfigurationOrBuilder getSourceCapabilityConfigurationOrBuilder() {
      if (sourceCapabilityConfigurationBuilder_ != null) {
        return sourceCapabilityConfigurationBuilder_.getMessageOrBuilder();
      } else {
        return sourceCapabilityConfiguration_ == null ?
            openfmb.commonmodule.SourceCapabilityConfiguration.getDefaultInstance() : sourceCapabilityConfiguration_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityConfiguration sourceCapabilityConfiguration = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.SourceCapabilityConfiguration, openfmb.commonmodule.SourceCapabilityConfiguration.Builder, openfmb.commonmodule.SourceCapabilityConfigurationOrBuilder> 
        getSourceCapabilityConfigurationFieldBuilder() {
      if (sourceCapabilityConfigurationBuilder_ == null) {
        sourceCapabilityConfigurationBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.SourceCapabilityConfiguration, openfmb.commonmodule.SourceCapabilityConfiguration.Builder, openfmb.commonmodule.SourceCapabilityConfigurationOrBuilder>(
                getSourceCapabilityConfiguration(),
                getParentForChildren(),
                isClean());
        sourceCapabilityConfiguration_ = null;
      }
      return sourceCapabilityConfigurationBuilder_;
    }

    private openfmb.commonmodule.ASG vAChaRteMax_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> vAChaRteMaxBuilder_;
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     * @return Whether the vAChaRteMax field is set.
     */
    public boolean hasVAChaRteMax() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     * @return The vAChaRteMax.
     */
    public openfmb.commonmodule.ASG getVAChaRteMax() {
      if (vAChaRteMaxBuilder_ == null) {
        return vAChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMax_;
      } else {
        return vAChaRteMaxBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     */
    public Builder setVAChaRteMax(openfmb.commonmodule.ASG value) {
      if (vAChaRteMaxBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        vAChaRteMax_ = value;
      } else {
        vAChaRteMaxBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     */
    public Builder setVAChaRteMax(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (vAChaRteMaxBuilder_ == null) {
        vAChaRteMax_ = builderForValue.build();
      } else {
        vAChaRteMaxBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     */
    public Builder mergeVAChaRteMax(openfmb.commonmodule.ASG value) {
      if (vAChaRteMaxBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          vAChaRteMax_ != null &&
          vAChaRteMax_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getVAChaRteMaxBuilder().mergeFrom(value);
        } else {
          vAChaRteMax_ = value;
        }
      } else {
        vAChaRteMaxBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     */
    public Builder clearVAChaRteMax() {
      bitField0_ = (bitField0_ & ~0x00000002);
      vAChaRteMax_ = null;
      if (vAChaRteMaxBuilder_ != null) {
        vAChaRteMaxBuilder_.dispose();
        vAChaRteMaxBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     */
    public openfmb.commonmodule.ASG.Builder getVAChaRteMaxBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getVAChaRteMaxFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getVAChaRteMaxOrBuilder() {
      if (vAChaRteMaxBuilder_ != null) {
        return vAChaRteMaxBuilder_.getMessageOrBuilder();
      } else {
        return vAChaRteMax_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMax_;
      }
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMax = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getVAChaRteMaxFieldBuilder() {
      if (vAChaRteMaxBuilder_ == null) {
        vAChaRteMaxBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getVAChaRteMax(),
                getParentForChildren(),
                isClean());
        vAChaRteMax_ = null;
      }
      return vAChaRteMaxBuilder_;
    }

    private openfmb.commonmodule.ASG vADisChaRteMax_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> vADisChaRteMaxBuilder_;
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     * @return Whether the vADisChaRteMax field is set.
     */
    public boolean hasVADisChaRteMax() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     * @return The vADisChaRteMax.
     */
    public openfmb.commonmodule.ASG getVADisChaRteMax() {
      if (vADisChaRteMaxBuilder_ == null) {
        return vADisChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMax_;
      } else {
        return vADisChaRteMaxBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     */
    public Builder setVADisChaRteMax(openfmb.commonmodule.ASG value) {
      if (vADisChaRteMaxBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        vADisChaRteMax_ = value;
      } else {
        vADisChaRteMaxBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     */
    public Builder setVADisChaRteMax(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (vADisChaRteMaxBuilder_ == null) {
        vADisChaRteMax_ = builderForValue.build();
      } else {
        vADisChaRteMaxBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     */
    public Builder mergeVADisChaRteMax(openfmb.commonmodule.ASG value) {
      if (vADisChaRteMaxBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          vADisChaRteMax_ != null &&
          vADisChaRteMax_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getVADisChaRteMaxBuilder().mergeFrom(value);
        } else {
          vADisChaRteMax_ = value;
        }
      } else {
        vADisChaRteMaxBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     */
    public Builder clearVADisChaRteMax() {
      bitField0_ = (bitField0_ & ~0x00000004);
      vADisChaRteMax_ = null;
      if (vADisChaRteMaxBuilder_ != null) {
        vADisChaRteMaxBuilder_.dispose();
        vADisChaRteMaxBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     */
    public openfmb.commonmodule.ASG.Builder getVADisChaRteMaxBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getVADisChaRteMaxFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getVADisChaRteMaxOrBuilder() {
      if (vADisChaRteMaxBuilder_ != null) {
        return vADisChaRteMaxBuilder_.getMessageOrBuilder();
      } else {
        return vADisChaRteMax_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMax_;
      }
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMax = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getVADisChaRteMaxFieldBuilder() {
      if (vADisChaRteMaxBuilder_ == null) {
        vADisChaRteMaxBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getVADisChaRteMax(),
                getParentForChildren(),
                isClean());
        vADisChaRteMax_ = null;
      }
      return vADisChaRteMaxBuilder_;
    }

    private openfmb.commonmodule.ASG wChaRteMax_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> wChaRteMaxBuilder_;
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     * @return Whether the wChaRteMax field is set.
     */
    public boolean hasWChaRteMax() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     * @return The wChaRteMax.
     */
    public openfmb.commonmodule.ASG getWChaRteMax() {
      if (wChaRteMaxBuilder_ == null) {
        return wChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMax_;
      } else {
        return wChaRteMaxBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     */
    public Builder setWChaRteMax(openfmb.commonmodule.ASG value) {
      if (wChaRteMaxBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        wChaRteMax_ = value;
      } else {
        wChaRteMaxBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     */
    public Builder setWChaRteMax(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (wChaRteMaxBuilder_ == null) {
        wChaRteMax_ = builderForValue.build();
      } else {
        wChaRteMaxBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     */
    public Builder mergeWChaRteMax(openfmb.commonmodule.ASG value) {
      if (wChaRteMaxBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          wChaRteMax_ != null &&
          wChaRteMax_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getWChaRteMaxBuilder().mergeFrom(value);
        } else {
          wChaRteMax_ = value;
        }
      } else {
        wChaRteMaxBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     */
    public Builder clearWChaRteMax() {
      bitField0_ = (bitField0_ & ~0x00000008);
      wChaRteMax_ = null;
      if (wChaRteMaxBuilder_ != null) {
        wChaRteMaxBuilder_.dispose();
        wChaRteMaxBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     */
    public openfmb.commonmodule.ASG.Builder getWChaRteMaxBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getWChaRteMaxFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getWChaRteMaxOrBuilder() {
      if (wChaRteMaxBuilder_ != null) {
        return wChaRteMaxBuilder_.getMessageOrBuilder();
      } else {
        return wChaRteMax_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMax_;
      }
    }
    /**
     * <pre>
     * Active Power Charge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMax = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getWChaRteMaxFieldBuilder() {
      if (wChaRteMaxBuilder_ == null) {
        wChaRteMaxBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getWChaRteMax(),
                getParentForChildren(),
                isClean());
        wChaRteMax_ = null;
      }
      return wChaRteMaxBuilder_;
    }

    private openfmb.commonmodule.ASG wDisChaRteMax_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> wDisChaRteMaxBuilder_;
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     * @return Whether the wDisChaRteMax field is set.
     */
    public boolean hasWDisChaRteMax() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     * @return The wDisChaRteMax.
     */
    public openfmb.commonmodule.ASG getWDisChaRteMax() {
      if (wDisChaRteMaxBuilder_ == null) {
        return wDisChaRteMax_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMax_;
      } else {
        return wDisChaRteMaxBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     */
    public Builder setWDisChaRteMax(openfmb.commonmodule.ASG value) {
      if (wDisChaRteMaxBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        wDisChaRteMax_ = value;
      } else {
        wDisChaRteMaxBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     */
    public Builder setWDisChaRteMax(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (wDisChaRteMaxBuilder_ == null) {
        wDisChaRteMax_ = builderForValue.build();
      } else {
        wDisChaRteMaxBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     */
    public Builder mergeWDisChaRteMax(openfmb.commonmodule.ASG value) {
      if (wDisChaRteMaxBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          wDisChaRteMax_ != null &&
          wDisChaRteMax_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getWDisChaRteMaxBuilder().mergeFrom(value);
        } else {
          wDisChaRteMax_ = value;
        }
      } else {
        wDisChaRteMaxBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     */
    public Builder clearWDisChaRteMax() {
      bitField0_ = (bitField0_ & ~0x00000010);
      wDisChaRteMax_ = null;
      if (wDisChaRteMaxBuilder_ != null) {
        wDisChaRteMaxBuilder_.dispose();
        wDisChaRteMaxBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     */
    public openfmb.commonmodule.ASG.Builder getWDisChaRteMaxBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getWDisChaRteMaxFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getWDisChaRteMaxOrBuilder() {
      if (wDisChaRteMaxBuilder_ != null) {
        return wDisChaRteMaxBuilder_.getMessageOrBuilder();
      } else {
        return wDisChaRteMax_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMax_;
      }
    }
    /**
     * <pre>
     * Active Power Discharge Maximum
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMax = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getWDisChaRteMaxFieldBuilder() {
      if (wDisChaRteMaxBuilder_ == null) {
        wDisChaRteMaxBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getWDisChaRteMax(),
                getParentForChildren(),
                isClean());
        wDisChaRteMax_ = null;
      }
      return wDisChaRteMaxBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.ESSCapabilityConfiguration)
  }

  // @@protoc_insertion_point(class_scope:essmodule.ESSCapabilityConfiguration)
  private static final openfmb.essmodule.ESSCapabilityConfiguration DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.ESSCapabilityConfiguration();
  }

  public static openfmb.essmodule.ESSCapabilityConfiguration getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ESSCapabilityConfiguration>
      PARSER = new com.google.protobuf.AbstractParser<ESSCapabilityConfiguration>() {
    @java.lang.Override
    public ESSCapabilityConfiguration parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ESSCapabilityConfiguration> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ESSCapabilityConfiguration> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.ESSCapabilityConfiguration getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

